#include <sys/stat.h>
#include <unistd.h>
#include <dirent.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <fcntl.h>

#define BUFSIZE 8192
int FIXHTTPLINK = 0;
int TESTONLY = 0;
int RECURSIVE = 1;
int CASESENSITIVE = 1;
int SHOWFILENAME = 0;
char *ext = NULL;
char *keyword = NULL;
char *replace = NULL;
char prefix[128];

int copy_file(destfile, sourcefile) 
char *destfile;
char *sourcefile;
{
  int dest, source, rcount;
  char buf[BUFSIZE];
  if ((source = open(sourcefile, O_RDONLY)) == -1) {
    printf("Can not read file: %s\n", sourcefile);
    return -1;
  }
  if ((dest = open(destfile, O_CREAT|O_WRONLY|O_TRUNC)) == -1) {
    printf("Can not create file: %s\n", destfile);
    close(source);
    return -1;
  }
  while ((rcount = read(source, buf, BUFSIZE)) > 0) {
    if ( write(dest, buf, rcount) != rcount ) {
      printf("Write file Error: %s\n", destfile);
      close(source);
      close(dest);
      return -1;
    }
  }
  close(source);
  close(dest);
  return 0;
}

void stricpy(dest, source)
char *dest;
char *source;
{ while ( *source ) *dest++ = tolower(*source++);}

void toLowerCase(dest)
char *dest;
{ stricpy(dest, dest);}

char* mystrstr(dest, key)
char *dest;
char *key;
{
  if ( CASESENSITIVE ) return strstr(dest, key);
  else {
    char *ptr = key;
    while ( *dest ) {
      if ( tolower(*dest++) == *ptr++ ) {
        if ( !*ptr ) return dest-strlen(key);
      } else ptr = key;
    }
  }
  return NULL;
}

void search_file(filename)
char *filename;
{
  int i, file, nfile, rcount, adjust;
  int klen = strlen(keyword);
  int plen = strlen(prefix);
  int rlen = (replace) ? strlen(replace) : 0;
  char *tempfile = "temp8192";
  char buf[BUFSIZE+1];
  char *ptr, *hit, *last;
  if ((file = open(filename, O_RDONLY)) == -1) {
    printf("Can not read file: %s\n", filename);
    return;
  }
  if (replace && !TESTONLY &&
     (nfile = creat(tempfile, S_IREAD|S_IWRITE)) == -1) {
    printf("Can not create file: %s\n", filename);
    close(file);
    return;
  }
  adjust = 0;
  buf[BUFSIZE] = 0;
  while ((rcount = read(file, buf+adjust, BUFSIZE-adjust)) > 0) {
    *(last=((ptr=buf)+adjust+rcount)) = 0;
    while ( (hit = mystrstr(ptr, keyword)) != NULL ) {
      printf("%s:", filename);
      for (i=0; (hit[i]>=' ') && (i<klen+30);)
        printf("%c", hit[i++]);
      printf("\n");
      if (replace) {
        if (!TESTONLY) {
          write(nfile, ptr, hit-ptr);
          write(nfile, replace, rlen);
        }
        printf("-> %s", replace);
        for (i=klen; (hit[i]>=' ') && (i<klen+30);)
          printf("%c", hit[i++]);
        printf("\n");
      }
      ptr = hit+klen;
    }
    adjust = klen-1;
    if ( last < buf+adjust ) adjust = last-buf;
    if ( (last-=adjust) > ptr ) {
      if (replace && !TESTONLY) write(nfile, ptr, last-ptr);
      strcpy(buf, last);
    }
  } 
  close(file);
  if (replace && !TESTONLY) {
    write(nfile, buf, strlen(buf));
    close(nfile);
    if ( copy_file(filename, tempfile) == 0 ) 
      unlink(tempfile);
  }
}

void file_process(filename)
char *filename;
{
  if (SHOWFILENAME) printf("%s\n", filename);
  if ( keyword != NULL ) search_file(filename);
}

int isDirectory(filename)
char *filename;
{
  struct stat buf;
  return ((stat(filename, &buf) == 0) && S_ISDIR(buf.st_mode));
}

int isRegularFile(filename)
char *filename;
{
  struct stat buf;
  return ((stat(filename, &buf) == 0) && S_ISREG(buf.st_mode));
}

void search_dir(dirname)
char *dirname;
{
  DIR *dir;
  struct dirent *ent;
  char filename[257];
  if ((dir = opendir(dirname)) == NULL) {
    perror("Unable to open directory.\n");
    return;
  }
  while ((ent = readdir(dir)) != NULL) {
    sprintf(filename, "%s/%s", dirname, ent->d_name);
    if (isRegularFile(filename)) {
      if ( (ext == NULL) || (strstr(ent->d_name, ext) != NULL))
        file_process(filename);
    }
  }
  if (RECURSIVE) {
    rewinddir(dir);
    strcat(prefix, "../");
    while ((ent = readdir(dir)) != NULL) {
      if ((ent->d_name[0] != '.') || 
         ((ent->d_name[1] != 0) && 
         ((ent->d_name[1] != '.') || (ent->d_name[2] != 0)))) {
        sprintf(filename, "%s/%s", dirname, ent->d_name);
        if (isDirectory(filename)) search_dir(filename);
      }
    }
    prefix[strlen(prefix)-3]=0;
  }
  closedir(dir);
}

void main(argc, argv)
int argc;
char *argv[];
{
  int count = 2;
  char keywordBuf[128];
  char replaceBuf[128];
  if (argc < count) {
    printf("usage: sf dirname [-i][-f][-t][-v][-eExt][-kKeyword][-rReplace]\n");
    printf("-i for No Case Sensitive (default Case Sensitive)\n");
    printf("-f for trying to fix http link (defualt no fix)\n");
    printf("-t for Test only (defualt no test)\n");
    printf("-v for Vervose (default no vervose)\n");
    printf("Eg. sf . -f -ehtml -k\n");
    exit(1);
  }
  for (; count<argc; count++) {
    if ( argv[count][0] == '-' ) {
      switch ( argv[count][1] ) {
        case 'e': 
          ext = argv[count]+2; 
          if ( ext[0] == 0 ) ext = NULL;
          else printf("  Ext=%s\n", ext);
          break;
        case 'k': 
          keyword = argv[count]+2;
          if ( keyword[0] == 0 ) {
          REPEAT:
            printf("  Please input Keyword: ");
            gets(keyword=keywordBuf);
            if (!*keyword) {
              printf("  Invalid Keyword!\n");
              goto REPEAT;
            }
          }
          printf("  Keyword=%s\n", keyword);
          break;
        case 't':
          TESTONLY = 1;
          break;
        case 'v':
          SHOWFILENAME = 1;
          break;
        case 'f':
          FIXHTTPLINK = 1;
          replace=prefix;
          break;
        case 'r': 
          replace = argv[count]+2;
          if ( replace[0] == 0 ) {
            printf("  Please input Replace String: ");
            gets(replace=replaceBuf);
          }
          printf("  Replace=%s\n", replace);
          break;
        case 'i':
          CASESENSITIVE = 0;
          break;
      }
    }
  }
  strcpy(prefix, "");
  if (!CASESENSITIVE && (keyword != NULL)) toLowerCase(keyword);
  if (isDirectory(argv[1])) search_dir(argv[1]);
  else file_process(argv[1]); 
}
